routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','frontController@index');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('verifyEmailFirst','Auth\RegisterController@verifyEmailFirst')->name('verifyEmailFirst');

Route::get('verify/{email}/{verifyToken}','Auth\RegisterController@sendEmailDone')->name('sendEmailDone');
Route::get('home/users/{id}/edit','userController@edit')->name('showUser');
Route::resource('home/users','userController');
Route::get('home/users/profile/{id}','userController@show')->name('showProfile');
Route::get('home/moderations/users','app\userController@moderation')->name('moderations');
Route::get('home/register/users','app\userController@register')->name('create');
Route::get('home/verifications/users','app\userController@verification')->name('verifications');
Route::PUT('home/moderation/{id}','app\userController@endModerate')->name('endModerate');
Route::get('home/moderation/uploadfile/{id}','app\userController@docsUpdate')->name('docsUpdate');
Route::PUT('home/moderation/uploadfile/{id}','app\userController@docsStore')->name('docsStore');

Route::get('home/users/profile/workexperience/{id}','app\userController@workExperiencesEdit')->name('workExperienceEdit');
Route::PUT('home/users/profile/workexperience/{id}','app\userController@workExperiencesPublic')->name('workExperiencePublic');
//Horarios de trabajo Sanatorio
Route::get('home/users/profile/horario/sanatorio/{id}','app\userController@horariosSanatorios')->name('horariosSanatorios');
Route::PUT('home/users/profile/horario/sanatorio/{id}','app\userController@horariosSanatoriosUpdate')->name('horariosSanatoriosUpdate');
//Horaio de trabajo Hospital
Route::get('home/users/profile/horario/hospital/{id}','app\userController@horariosHospitales')->name('horariosHospital');
Route::PUT('home/users/profile/horario/hospital/{id}','app\userController@horariosHospitalesUpdate')->name('horariosHospitalUpdate');
#Horario de trabajo en Domicilio
Route::get('home/users/profile/horario/domicilio/{id}','app\userController@horariosDomicilios')->name('horariosDomicilio');
Route::PUT('home/users/profile/horario/domicilio/{id}','app\userController@horariosDomiciliosUpdate')->name('horariosDomicilioUpdate');
// Redirect the user to the provider authentication page
Route::get('auth/facebook', 'Auth\SocialAuthController@redirectToProvider')->name('social.auth');
Route::get('auth/facebook/callback', 'Auth\SocialAuthController@handleProviderCallback');
#
#Routas para el costo de los servicios
Route::resource('/home/contabilidad/costo','costoController'); 
#
#Routes para Manejo de las tasas de cambios
Route::resource('/home/contabilidad/tasadecambio','tasaCambioController');
#Route para el manejo de las membresias
Route::resource('/home/productos/membresia','membresiaController');
#Ruta para manejo de Servicios
Route::resource('/home/productos/servicios','serviciosController');
#Route para manejo de los costos de las membresias
Route::resource('/home/contabilidad/costoMembresia','membresiaCostoController');
#Routes para las contrataciones de servicios
Route::resource('/home/contrato','contratosController');
#
#Contrat de Membresias
Route::resource('/home/productos/contrato/membresias','membresiaContratoController');
#
Route::resource('/home/invoice','facturaController');
#
#Routes para los pagos MercadoPago y PayPal
Route::post('/home/invoice/payout','payController@pagosMercadoPago')->name('recibirPagos');




#seecion de desarrollo para atencion al cliente
Route::get('/home/atencion_al_cliente/membresias','app\atencionCliente@membresiaVentasIndex')->name('ventaMembresia');
Route::get('/home/atencion_al_cliente/ventas/membresias','app\atencionCliente@membresiaVentasShow')->name('ventaMembresiaUsuario');
Route::GET('/home/atencion_al_cliente/ventas/membresias/usuario_registrado/','app\atencionCliente@membresiaVentasPais')->name('ventaMembresiaPais');

// Seccion de contabilidad para atencion al cliente
Route::get('/home/contabilidad/atencion_al_cliente/membresias/{id}/vendedor','app\atencionCliente@resumenVentas')->name('resumenVentas');

//SEccion de Comisiones
Route::get('/home/comisiones','app\comisionesController@mostrarComisiones')->name('comisiones.show');
Route::get('/home/comisiones/call_center','app\comisionesController@mostrarComisionesCallCenter')->name('comisionesCall.show');
Route::get('/home/comisiones/referidos','app\comisionesController@mostrarComisionesReferidos')->name('comisionesReferidos.show');

app/contratos.php
<?php

namespace acompana;

use Illuminate\Database\Eloquent\Model;

class contratos extends Model
{
    protected $table = 'contratos';
    protected $fillable = [
		'fechaInicio',
		'fechaFin',
		'horario_id',
		'ciudad',
		'cuidadores',
		'servicio',
		'factura_id',
		'user_id',
    ];

    public function factura(){
        return $this->belongsTo(factura::class,'factura_id');
    }
     public function usuario(){
        return $this->belongsTo(User::class,'user_id');
    }
}

app/Http/Controllers/contratosController.php
<?php

namespace acompana\Http\Controllers;

use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use acompana\User;
use acompana\Pais;
use acompana\Ciudad;
use acompana\services;
use acompana\contratos;
use acompana\factura;
use acompana\costoSanatorio;
use acompana\costoHospital;
use acompana\costoDomicilio;


class contratosController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {   
        $ciudades = Ciudad::all();
        return view('dashboard.contratos.booking',compact('ciudades'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request, $id)
    {
        $fechaInicio = $request->fechaInicioContrato;
        $fechaFin = $request->fechaFinContrato;

        $ciudad = $request->ciudad;
        $servicio = $request->servicio;
        $id = decrypt($id);
        
        $user = user::where([
            ['country',$id],
            ['status','3'],
            ['estado',  $ciudad]
            ])->paginate(10);
        if($servicio == 1){
            $costo = costoDomicilio::where('idPais',$id)->get();
        }elseif($servicio == 2){
            $costo = costoHospital::where('idPais',$id)->get();
        }elseif($servicio == 2){
            $costo = costoSanatorio::where('idPais',$id)->get();
        }
        $ciudades = Ciudad::where('PaisCodigo',$id)->get();
        return view('dashboard.contratos.buscar',compact('user','ciudades', 'ciudad' ,'id','servicio','fechaInicio','fechaFin','costo'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        
        $id = decrypt($id);
        
        $descuento = $request->descuento; //--> este descuento debe ser expresado en porcentaje
        $dias = $request->dias *8;
        $costo = $request->costoMonedaLocal;
        $contrato = new contratos;
        $contrato->fill($request->all());
        $contrato->ciudad = $request->estado;
        $contador=0;
        $cuidador;
        if(!empty($request->cuidadores[0])){
        foreach ($request->cuidadores as $cuidadores ) {
            if(empty($cuidador)){
                $cuidador = $cuidadores;
                $contador = $contador+1;
            }else{
                $cuidador = $cuidador . "|" . $cuidadores;
                $contador = $contador+1;
            }
            
        }
        $contrato->user_id = $id;
        $contrato->cuidadores = $cuidador;
        $contrato->save();
        $factura = new factura;
        $factura->contrato_id = $contrato->id;
        $factura->subTotal = $dias * 8 * $costo;
        $factura->tax = $factura->subTotal * 0.16;
        $subTotal = $factura->subTotal + $factura->tax;
        $factura->descuento = $subTotal * $descuento;
        $factura->total = $subTotal - $factura->descuento;
        $factura->estado = 1;
        $factura->monedaLocal = $request->MonedaLocal;
        $factura->save();
        $contrato->factura_id = $factura->id;
        $contrato->save();

        return redirect(route('invoice.show',['invoice'=>encrypt($contrato->id)]));

        }else{
            return back();
        }

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/dashboard/contratos/booking.blade.php
@extends('Templates.Dashboard.users')
@section('body')
<div class="card">
<div class="card-header">
<h5>¡Contrata un Cuidador ahora!</h5>
<span>Seleccione los campos necesarios para proceder con la contratación. <br>
recuerde que si usted requiere de mas de 6 días continuos debe contratatar a 2 personas distintas</span>
</div>
<div class="card-block">
<div class="row">
<div class="col-md-12">
<div id="wizard">
<section>
<form class="wizard-form" id="example-advanced-form" method="GET" action="{{route('contrato.show',['contrato'=>encrypt(Auth::user()->country)])}}" enctype="multipart/form-data">
{{ csrf_field() }}
<h3> Contratación </h3>
<fieldset>
<div class="form-group row">
<div class="col-md-4 col-lg-2">
<label for="email-2" class="block">Tipo de servicio a contratar</label>
</div>
<div class="col-md-8 col-lg-10">
	<select class="form-control" name="servicio">
			<option>Seleccione el tipo de servicio</option>
			<option value="1">Servicio en Domicilio</option>
			<option value="2">Servicio en Hospitales</option>
			<option value="3">Servicio en Sanatorio</option>
	</select>
</div>
</div>
<div class="form-group row">
<div class="col-md-4 col-lg-2">
<label for="email-2" class="block">Seleccione la ciudad a contratar</label>
</div>
<div class="col-md-8 col-lg-10">
<select class="form-control" name="ciudad">
<option>Seleccione la Ciudad</option>
<?php foreach ($ciudades as $ciudad) { ?>
	<?php if($ciudad->PaisCodigo == Auth::user()->country){ ?>
	<option value="{{$ciudad->CiudadID}}"> {{$ciudad->CiudadNombre}}</option>
<?php }} ?>
</select>
</div>
</div>
<div class="form-group row">
<div class="col-md-4 col-lg-2">
<label for="password-2" class="block">Fecha de inicial</label>
</div>
<div class="col-md-8 col-lg-10">
<input type="date" class="form-control date-control" name="fechaInicioContrato" value="<?php echo date("Y-m-d");?>" min=<?php echo date("Y-m-d");?>>
</div>
</div>
<div class="form-group row">
<div class="col-md-4 col-lg-2">
<label for="confirm-2" class="block">Fecha de final</label>
</div>
<div class="col-md-8 col-lg-10">
<input type="date" class="form-control date-control" name="fechaFinContrato" value="<?php echo date("Y-m-d");?>" min=<?php echo date("Y-m-d");?>>
</div>
</div>
</fieldset>
</form>
</section>
</div>
</div>
</div>
</div>
</div>


@stop

resources/views/dashboard/contratos/buscar.blade.php
@extends('Templates.Dashboard.index')
@section('body')
<!-- Información -->
<?php 
$inicio = new dateTime($fechaInicio);
$fin = new dateTime($fechaFin);
$fechas = $fin->diff($inicio);
$cuidador = $fechas->d/6;
$cuidador = intval($cuidador);
$fechas->d = $fechas->d+1;
$resto = $fechas->d%6;
if($resto != 0){
  		$cuidador++;
  		
}



if($fechas->d > 6 ){

 ?>
<div class="alert alert-danger" role="alert">
  Usted a seleccionado un servicio por un aproximado de <?php echo $fechas->d ?> días, <strong>Recuerde: </strong> ustéd solo debe contratar un cuidador por un máximo de 6días continuos. <br>
  Para continuar debe seleccionar <strong><?php echo $cuidador; ?></strong> cuidadores.
</div>
<?php } ?>
 <!-- Left column start -->
<div class="alert alert-success" role="alert">
	Usted está contratando un servicio por una cantidad de <?php if($fechas->d == 0){ echo 1;}else{echo $fechas->d;} ?> días, para el cual usted deberá seleccionar <?php if($fechas->d == 0){ echo 1;}else{  echo $cuidador;} ?> cuidador(es), correspondiente a los días desde <strong><?php echo date('d-M',strtotime($fechaInicio)) ?></strong> hasta <strong><?php echo date('d-M',strtotime($fechaFin)) ?></strong>
	<br>
<div class="clear-fix"></div>
<div class="container row">
	<div class="col-lg-6">
		<div class="text-left">
			<a href="{{ url()->previous() }}"  style="color:white" class="btn btn-danger waves-effect waves-light btn-sm"> Cancelar
			</a>
		</div>
	</div>
	<div class="col-lg-6">
		<div class="text-right">
			<button type="submit" class="btn btn-success waves-effect waves-light btn-sm" onclick="event.preventDefault();
 		document.getElementById('procederContrato').submit();"> Continuar
			</button>
		</div>
	</div>
</div>


</div>
<div class="row">

<div class="col-lg-9">
<form method="POST" id="procederContrato" action="{{route('contrato.update',['contrato' => encrypt(Auth::user()->id)])}}">
{{ method_field('PUT')}}
{{ csrf_field() }}
<!-- entradas heredadas -->
<input type="hidden" name="fechaInicio" value="{{ date('Y-m-d',strtotime($fechaInicio))}}">
<input type="hidden" name="fechaFin" value="{{ date('Y-m-d',strtotime($fechaFin))}}">
<input type="hidden" name="cuidador" value="{{ $cuidador }}">
<input type="hidden" name="estado" value="{{ $ciudad }}">
<input type="hidden" name="servicio" value="{{ $servicio }}">
<input type="hidden" name="costoDolar" value="{{ $costo[0]->costoDolar }}">
<input type="hidden" name="costoMonedaLocal" value="{{ $costo[0]->costoDolar * $costo[0]->tasaCambio}}">
<input type="hidden" name="MonedaLocal" value="{{ $costo[0]->monedaLocal}}">
<input type="hidden" name="dias" value="{{ $fechas->d }}">


<!-- fin de entradas heredadas -->
<div class="job-card card-columns">
<!-- Job card start -->
@foreach($user as $usuario)
<?php if($usuario->status == 3){ ?>
<?php if(!empty($servicio)){ ?>
<div class="card">
<div class="card-header">
<div class="media">
<a class="media-left media-middle" href="#">
<img class="media-object img-60" src="https://www.acompaño.com/users_images/{{$usuario->avatar}}" alt="Generic placeholder image">
</a>
<div class="media-body media-middle">
<div class="company-name">
<p>{{$usuario->name}} {{$usuario->lastName}}</p>
<span class="text-muted f-14">{{ date('M d, Y',strtotime($usuario->created_at))}}</span>
</div>
<?php 
$registro = new DateTime($usuario->created_at);
$hoy = new DateTime();
$tiempo = $hoy->diff($registro);
if($tiempo->d < 15){
?>
<div class="job-badge">
<label class="label bg-primary">Nuevo</label>
</div>
<?php } ?>
</div>
</div>
</div>
<div class="card-block">
<p class="text-muted">
<!-- aqui se introduce la descripción -->
</p>
<div class="job-lable">
<?php if(!empty($usuario->servicio->hospitales)){ ?><label class="label badge-success"> <?php echo 'Hospitales';?></label><?php } ?>
<?php if(!empty($usuario->servicio->domicilios)){ ?><label class="label badge-warning"> <?php echo 'Domicilios';?></label><?php } ?>
<?php if(!empty($usuario->servicio->sanatorios)){ ?><label class="label badge-danger"> <?php echo 'Sanatorio';?></label><?php } ?>
</div>
<div class="row">
<div class="col-lg-6">
<div class="job-meta-data"><i class="icofont icofont-safety"></i>{{ $usuario->estados->CiudadNombre}}</div>
<div class="job-meta-data"><i class="icofont icofont-university"></i><?php 
	$cumpleanos = new DateTime($usuario->BirthDay);
    $edad = $hoy->diff($cumpleanos);
    echo $edad->y;

 ?> años</div>
</div>
<div class="col-lg-6 text-right">
	<h4 class="precio" style="color: black"><?php echo $costo[0]->costoDolar * $costo[0]->tasaCambio . $costo[0]->monedaLocal?><small>/h</small></h4>
</div>
</div>
<div class="row">
	<div class="col-xs-7 row">
		<div class="col-lg-6"><label for="chack">Seleccionar </label></div>
		<div class="col-lg-5"><input id="check" type="checkbox" class="js-single" name="cuidadores[]" value="{{$usuario->id}}"/></div>
	</div>
	<div class="col-xs-4 text-right">
			<button type="button" class="btn btn-primary waves-effect waves-light btn-sm" data-toggle="modal" data-target="#usuarioModal{{$usuario->id}}"> Ver Perfil
		</button>
	</div>
</div>

</div>
</div>
<!-- Modal -->
<div class="modal fade" id="usuarioModal{{$usuario->id}}" tabindex="-1" role="dialog" aria-labelledby="usuarioModal{{ $usuario->id}}Label" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div style="height: 60rem"class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">{{$usuario->name}} {{$usuario->lastName}}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div style="height: 58rem" class="modal-body">
        <iframe style="width: 100%;height: 100%" src="{{route('users.show',['user'=>encrypt($usuario->id)])}}" frameborder="0"></iframe>
      </div>
    </div>
  </div>
</div>
<!-- END MODAL -->
<?php } ?>
<?php } ?>
@endforeach
</div>
</form>
<?php 
$currentPage = $user->currentPage();
$maxPage = $currentPage + 5;
$firstPage = 1;
$lastPage = $user->lastPage();
$nextPage = $currentPage + 1 ;
$forwardPage = $currentPage - 1;
$user->setPath('');
?>
<!-- Pagination start -->
<nav aria-label="...">
<ul class="pagination justify-content-center m-t-20 m-b-20">
<li class="page-item <?php if($currentPage == $firstPage) : echo 'disabled'; endif ?> ">
<a class="page-link" href="
<?php  if($currentPage>1) : echo $user->url($forwardPage); else :   echo "#";  endif ?>" 
tabindex="-1">Anterior</a>
</li>
<?php for($x=$currentPage;$x<$maxPage;$x++){ ?>
	<?php if($x <= $lastPage){ ?>
	<li class="page-item <?php if($x ==$currentPage) : ?> active <?php endif ?>">
		<a class="page-link" href="<?php echo $user->url($x) ?>"> <?php echo $x; ?></a>
	</li>
	<?php } ?>
<?php } ?>
<li class="page-item <?php if($currentPage == $firstPage) : echo 'disabled'; endif ?>">
<a class="page-link" href="<?php if($currentPage < $lastPage) : echo $user->url($x); else : echo "#"; endif ?>">Siguiente</a>
</li>
</ul>
</nav>
<!-- Pagination end -->
</div>

<!-- Left column end -->
<!-- Right column start -->
<div class="col-lg-3 col-md-12">
<!-- Filter card start -->
<div class="card">
<div class="card-header">
<h5><i class="icofont icofont-filter m-r-5"></i>Filtro</h5>
</div>
<div class="card-block">
<form action="{{route('contrato.show',['contrato'=>encrypt($id)])}}" role='search' method="GET">
<div class="form-group row">
<div class="col-sm-12">
<select class="form-control" name="ciudad">
<option>Seleccione la Ciudad</option>
<?php foreach ($ciudades as $ciudad) { ?>
	<option value="{{$ciudad->CiudadID}}"> {{$ciudad->CiudadNombre}}</option>
<?php } ?>
</select>
</div>
</div>
<div class="form-group row">
<div class="col-sm-12">
<select class="form-control" name="servicio">
<option>Seleccione el tipo de servicio</option>
<option value="1">Servicio en Domicilio</option>
<option value="2">Servicio en Hospitales</option>
<option value="3">Servicio en Sanatorio</option>
</select>
</div>
</div>
<div class="text-right">
<button type="submit" class="btn btn-primary">
<i class="icofont icofont-job-search m-r-5"></i> Cuidador
</button>
</div>
</form>
</div>
</div>
<!-- Filter card end -->
<!-- Location card start -->

<!-- Location card end -->
<!-- Job Title card start -->

<!-- Job Title card end -->
<!-- Recent Searches card end -->
</div>
</div>
</div>


 @stop

resources/views/dashboard/contratos/contratos.blade.php
@extends('Templates.Dashboard.index')
@section('body')
<!-- Información -->
<div class="row">

<div class="col-lg-12">

<div class="job-card card-columns">
@foreach($contratos as $contrato)
<?php if($contrato->user_id == Auth::user()->id){ ?>
<div class="col-sm-12">
<div class="card card-border-primary">
<div class="card-header">
<h5><?php echo Auth::user()->name ?> <?php echo Auth::user()->lastName ?></h5>
<!-- <span class="label label-default f-right"> 28 January, 2015 </span> -->
</div>
<div class="card-block">
<div class="row">
<div class="col-sm-6">
<ul class="list list-unstyled">
<li>Factura #: ACOMPA-<?php echo $contrato->factura->id ?></li>
<li>Facturado: <span class="text-semibold"><?php echo date('Y/m/d',strtotime($contrato->factura->created_at)) ?></span></li>
</ul>
</div>
<div class="col-sm-6">
<ul class="list list-unstyled text-right">
<li><?php echo  $contrato->factura->total . " " . $contrato->factura->monedaLocal  ?></li>
<li>Servicio: <span class="text-semibold">
<?php if($contrato->servicio == 1){ echo "Domicilio";} ?>
<?php if($contrato->servicio == 2){ echo "Hospitales";} ?>
<?php if($contrato->servicio == 3){ echo "Sanatorios";} ?>
</span></li>
</ul>
</div>
</div>
</div>
<div class="card-footer">
<div class="task-board m-0">
<a href="{{ route('invoice.show',['invoice'=>encrypt($contrato->id)])}}" class="btn btn-info btn-mini b-none"><i class="icofont icofont-eye-alt m-0"></i></a>
<!-- end of dropdown-secondary -->
</div>
</div>
</div>
</div>
<?php } ?>
@endforeach

</div>
</div>
</div>


 @stop